-- ATTACK
oldIssueAttack = IssueAttack
function IssueAttack( units, position )
	if not table.empty(units) then
		-- Only check unit locks if the co-op team has a human player
		local army = teams.data.armies[units[1]:GetArmy()]
		if not army.Human and teams.data.teams[army.Team].hasHumans then
			--LOG('IssueAttack')
			for i,unit in units do
				local lock = unit:GetLock()
				if lock then
					unit:SetCustomLabel('Attack blocked by '..lock)
					table.remove(units,i)
				end
			end
		end
		oldIssueAttack( units, position )
	end
end

-- AGGRESSIVE MOVE
oldIssueAggressiveMove = IssueAggressiveMove
function IssueAggressiveMove( units, position )
	if not table.empty(units) then
		-- Only check unit locks if the co-op team has a human player
		local army = teams.data.armies[units[1]:GetArmy()]
		if not army.Human and teams.data.teams[army.Team].hasHumans then
			--LOG('IssueAggressiveMove')
			for i,unit in units do
				local lock = unit:GetLock()
				if lock then
					unit:SetCustomLabel('AggressiveMove blocked by '..lock)
					table.remove(units,i)
				end
			end
		end
		oldIssueAggressiveMove( units, position )
	end
end

-- BUILD FACTORY
oldIssueBuildFactory = IssueBuildFactory
function IssueBuildFactory( units )
	if not table.empty(units) then
		-- Only check unit locks if the co-op team has a human player
		local army = teams.data.armies[units[1]:GetArmy()]
		if not army.Human and teams.data.teams[army.Team].hasHumans then
			LOG('IssueBuildFactory')
			for i,unit in units do
				local lock = unit:GetLock()
				if lock then
					unit:SetCustomLabel('Clear blocked by '..lock)
					table.remove(units,i)
				end
			end
		end
		oldIssueBuildFactory( units )
	end
end

-- BUILD MOBILE
oldIssueBuildMobile = IssueBuildMobile
function IssueBuildMobile( units )
	if not table.empty(units) then
		-- Only check unit locks if the co-op team has a human player
		local army = teams.data.armies[units[1]:GetArmy()]
		if not army.Human and teams.data.teams[army.Team].hasHumans then
			LOG('IssueBuildMobile')
			for i,unit in units do
				local lock = unit:GetLock()
				if lock then
					unit:SetCustomLabel('Clear blocked by '..lock)
					table.remove(units,i)
				end
			end
		end
		oldIssueBuildMobile( units )
	end
end

-- CAPTURE
oldIssueCapture = IssueCapture
function IssueCapture( units, target )
	if not table.empty(units) then
		-- Only check unit locks if the co-op team has a human player
		local army = teams.data.armies[units[1]:GetArmy()]
		if not army.Human and teams.data.teams[army.Team].hasHumans then
			LOG('IssueCapture')
			for i,unit in units do
				local lock = unit:GetLock()
				if lock then
					unit:SetCustomLabel('Clear blocked by '..lock)
					table.remove(units,i)
				end
			end
		end
		oldIssueCapture( units, target )
	end
end

-- CLEAR
oldIssueClearCommands = IssueClearCommands
function IssueClearCommands( units )
	if not table.empty(units) then
		-- Only check unit locks if the co-op team has a human player
		local army = teams.data.armies[units[1]:GetArmy()]
		if not army.Human and teams.data.teams[army.Team].hasHumans then
			--LOG('IssueClearCommands')
			for i,unit in units do
				local lock = unit:GetLock()
				if lock then
					unit:SetCustomLabel('ClearCommands blocked by '..lock)
					table.remove(units,i)
				end
			end
		end
		oldIssueClearCommands( units )
	end
end

-- CLEAR FACTORY
oldIssueClearFactoryCommands = IssueClearFactoryCommands
function IssueClearFactoryCommands( units )
	if not table.empty(units) then
		-- Only check unit locks if the co-op team has a human player
		local army = teams.data.armies[units[1]:GetArmy()]
		if not army.Human and teams.data.teams[army.Team].hasHumans then
			--LOG('IssueClearFactoryCommands')
			for i,unit in units do
				local lock = unit:GetLock()
				if lock then
					unit:SetCustomLabel('ClearFactoryCommands blocked by '..lock)
					table.remove(units,i)
				end
			end
		end
		oldIssueClearFactoryCommands( units )
	end
end

-- IssueDestroySelf 
-- IssueDive 
-- IssueFactoryAssist 
-- IssueFactoryRallyPoint 
-- IssueFerry 

-- FORM AGGRESSIVE MOVE
oldIssueFormAggressiveMove = IssueFormAggressiveMove
function IssueFormAggressiveMove( units, position )
	if not table.empty(units) then
		-- Only check unit locks if the co-op team has a human player
		local army = teams.data.armies[units[1]:GetArmy()]
		if not army.Human and teams.data.teams[army.Team].hasHumans then
			--LOG('IssueFormAggressiveMove')
			for i,unit in units do
				local lock = unit:GetLock()
				if lock then
					unit:SetCustomLabel('FormAggressiveMove blocked by '..lock)
					table.remove(units,i)
				end
			end
		end
		oldIssueFormAggressiveMove( units, position )
	end
end

-- FORM ATTACK
oldIssueFormAttack = IssueFormAttack
function IssueFormAttack( units, position )
	if not table.empty(units) then
		-- Only check unit locks if the co-op team has a human player
		local army = teams.data.armies[units[1]:GetArmy()]
		if not army.Human and teams.data.teams[army.Team].hasHumans then
			--LOG('IssueFormAttack')
			for i,unit in units do
				local lock = unit:GetLock()
				if lock then
					unit:SetCustomLabel('FormAttack blocked by '..lock)
					table.remove(units,i)
				end
			end
		end
		oldIssueFormAttack( units, position )
	end
end

-- FORM MOVE
oldIssueFormMove = IssueFormMove
function IssueFormMove( units, position )
	if not table.empty(units) then
		-- Only check unit locks if the co-op team has a human player
		local army = teams.data.armies[units[1]:GetArmy()]
		if not army.Human and teams.data.teams[army.Team].hasHumans then
			--LOG('IssueFormMove')
			for i,unit in units do
				local lock = unit:GetLock()
				if lock then
					unit:SetCustomLabel('FormMove blocked by '..lock)
					table.remove(units,i)
				end
			end
		end
		oldIssueFormMove( units, position )
	end
end

-- FORM PATROL
oldIssueFormPatrol = IssueFormPatrol
function IssueFormPatrol( units, position )
	if not table.empty(units) then
		-- Only check unit locks if the co-op team has a human player
		local army = teams.data.armies[units[1]:GetArmy()]
		if not army.Human and teams.data.teams[army.Team].hasHumans then
			--LOG('IssueFormPatrol')
			for i,unit in units do
				local lock = unit:GetLock()
				if lock then
					unit:SetCustomLabel('FormPatrol blocked by '..lock)
					table.remove(units,i)
				end
			end
		end
		oldIssueFormPatrol( units, position )
	end
end

-- GUARD
oldIssueGuard = IssueGuard
function IssueGuard( units, position )
	if not table.empty(units) then
		-- Only check unit locks if the co-op team has a human player
		local army = teams.data.armies[units[1]:GetArmy()]
		if not army.Human and teams.data.teams[army.Team].hasHumans then
			--LOG('IssueGuard')
			for i,unit in units do
				local lock = unit:GetLock()
				if lock then
					unit:SetCustomLabel('Guard blocked by '..lock)
					table.remove(units,i)
				end
			end
		end
		oldIssueGuard( units, position )
	end
end

-- IssueKillSelf

-- MOVE
oldIssueMove = IssueMove
function IssueMove( units, position )
	if not table.empty(units) then
		-- Only check unit locks if the co-op team has a human player
		local army = teams.data.armies[units[1]:GetArmy()]
		if not army.Human and teams.data.teams[army.Team].hasHumans then
			--LOG('IssueMove')
			for i,unit in units do
				local lock = unit:GetLock()
				if lock then
					unit:SetCustomLabel('Move blocked by '..lock)
					table.remove(units,i)
				end
			end
		end
		oldIssueMove( units, position )
	end
end

-- IssueMoveOffFactory 
-- IssueNuke 
-- IssueOverCharge 
-- IssuePatrol 
-- IssuePause 

-- PATROL
oldIssuePatrol = IssuePatrol
function IssuePatrol( units, position )
	if not table.empty(units) then
		-- Only check unit locks if the co-op team has a human player
		local army = teams.data.armies[units[1]:GetArmy()]
		if not army.Human and teams.data.teams[army.Team].hasHumans then
			--LOG('IssuePatrol')
			for i,unit in units do
				local lock = unit:GetLock()
				if lock then
					unit:SetCustomLabel('Patrol blocked by '..lock)
					table.remove(units,i)
				end
			end
		end
		oldIssuePatrol( units, position )
	end
end

-- RECLAIM
oldIssueReclaim = IssueReclaim
function IssueReclaim( units, target )
	if not table.empty(units) then
		-- Only check unit locks if the co-op team has a human player
		local army = teams.data.armies[units[1]:GetArmy()]
		if not army.Human and teams.data.teams[army.Team].hasHumans then
			--LOG('IssueReclaim')
			for i,unit in units do
				local lock = unit:GetLock()
				if lock then
					unit:SetCustomLabel('Reclaim blocked by '..lock)
					table.remove(units,i)
				end
			end
		end
		oldIssueReclaim( units, target )
	end
end

-- REPAIR
oldIssueRepair = IssueRepair
function IssueRepair( units, target )
	if not table.empty(units) then
		-- Only check unit locks if the co-op team has a human player
		local army = teams.data.armies[units[1]:GetArmy()]
		if not army.Human and teams.data.teams[army.Team].hasHumans then
			--LOG('IssueRepair')
			for i,unit in units do
				local lock = unit:GetLock()
				if lock then
					unit:SetCustomLabel('Repair blocked by '..lock)
					table.remove(units,i)
				end
			end
		end
		oldIssueRepair( units, target )
	end
end

-- IssueSacrifice 

-- STOP
oldIssueStop = IssueStop
function IssueStop( units )
	if not table.empty(units) then
		-- Only check unit locks if the co-op team has a human player
		local army = teams.data.armies[units[1]:GetArmy()]
		if not army.Human and teams.data.teams[army.Team].hasHumans then
			--LOG('IssueStop')
			for i,unit in units do
				local lock = unit:GetLock()
				if lock then
					unit:SetCustomLabel('Stop blocked by '..lock)
					table.remove(units,i)
				end
			end
		end
		oldIssueStop( units )
	end
end
