ScenarioUtils = import('/lua/sim/ScenarioUtilities.lua')

-- Moves all units and resources (except ACU) to another army
Callbacks.GiveArmyToPlayer = function(data)
	local fromArmy = data.From
	local toArmy = data.To
	local fromBrain = GetArmyBrain(fromArmy)
	local toBrain = GetArmyBrain(toArmy)
	
	-- Security check
	if not OkayToMessWithArmy(fromArmy) or fromBrain:IsDefeated() or toBrain:IsDefeated() then return end
	
	-- Transfer Resources
	local massTaken = fromBrain:TakeResource('Mass',data.Mass * fromBrain:GetEconomyStored('Mass'))
	local energyTaken = fromBrain:TakeResource('Energy',data.Energy * fromBrain:GetEconomyStored('Energy'))
	toBrain:GiveResource('Mass',massTaken)
	toBrain:GiveResource('Energy',energyTaken)
	
	-- Transfer Units
	local units = fromBrain:GetListOfUnits(categories.ALLUNITS, false)
	for k,v in units do
		-- Only allow units not attached to be given.
		-- This is because units will give all of it's children
		-- over as well, so we only want the top level units to be given.
		if v:GetParent() == v then
		    ScenarioUtils.GiveUnitToArmy(v,toArmy)
		end
	end
end