teams = coopimport('code/teams.lua')

-- Modified version of CreateInitialArmyGroup that spawns ACUs around team leader
function CreateInitialArmyGroup(strArmy, createCommander)
	local tblGroup = CreateArmyGroup( strArmy, 'INITIAL')
	local cdrUnit = false

	-- COOP: Change army name to team leaders army
	if not teams.IsLeader(strArmy) then
		LOG('COOP: No commander for army '..strArmy)
		createCommander = false
	end
	
	if createCommander and ( tblGroup == nil or 0 == table.getn(tblGroup) ) then
		local factionIndex = GetArmyBrain(strArmy):GetFactionIndex()
		local initialUnitName = import('/lua/factions.lua').Factions[factionIndex].InitialUnit
		cdrUnit = CreateInitialArmyUnit(strArmy, initialUnitName)
		if EntityCategoryContains(categories.COMMAND, cdrUnit) then
			if ScenarioInfo.Options['PrebuiltUnits'] == 'Off' then
				cdrUnit:PlayCommanderWarpInEffect()
			end
		end
	end

	return tblGroup, cdrUnit
end



